/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!rx_restricted_mem_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!rx_restricted_mem_operand (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!rx_compare_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x9, 1);
  operands[5] = x11;
  if (!rx_compare_operand (operands[5], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XEXP (x12, 1);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 16
          || GET_MODE (x2) != E_CCmode)
        return -1;
      return 0;

    case RETURN:
      return 1;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 3
      || XINT (x5, 1) != 20
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 2
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 3
      || GET_MODE (x8) != E_SImode)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 23
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 3
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2446 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
        return -1;
      *pnum_clobbers = 4;
      return 154; /* rx_strend */

    case 3:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 22
          || GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 1
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 2
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 3
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 1
          || GET_MODE (x7) != E_SImode
          || !
#line 2533 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
        return -1;
      *pnum_clobbers = 2;
      return 156; /* rx_setmem */

    case 1:
      if (XINT (x2, 1) != 39
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!immediate_operand (operands[1], E_SImode))
        return -1;
      return 172; /* mvfc */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XEXP (x2, 1);
  switch (GET_CODE (x9))
    {
    case MEM:
      if (GET_MODE (x9) != E_BLKmode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 2
          || GET_MODE (x10) != E_SImode
          || pattern38 (x1) != 0
          || pattern52 (x1, 
E_SImode, 
3, 
2, 
1) != 0
          || !
#line 2431 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
        return -1;
      return 153; /* rx_movstr */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x9, 0) != 2
          || XINT (x9, 1) != 23
          || GET_MODE (x9) != E_SImode)
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 3
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XVECEXP (x1, 0, 1);
      if (pattern9 (x12, 
1, 
CLOBBER, 
E_SImode) != 0
          || pattern52 (x1, 
E_CCmode, 
16, 
3, 
2) != 0)
        return -1;
      x13 = XEXP (x2, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x14 = XVECEXP (x9, 0, 0);
      operands[1] = x14;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2446 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
        return -1;
      return 154; /* rx_strend */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != COMPARE
          || GET_MODE (x5) != E_CCmode)
        return NULL;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 16
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x5, 0);
      if (rtx_equal_p (x8, operands[0]))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_1 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_2 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (rx_restricted_mem_operand (operands[1], E_HImode))
            {
              x4 = PATTERN (peep2_next_insn (1));
              switch (pattern39 (x4))
                {
                case 0:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_3 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_19 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 1:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_4 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_20 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 2:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_5 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_21 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 3:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_6 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_22 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 4:
                  if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_35 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 5:
                  if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_36 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 6:
                  if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_37 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 7:
                  x5 = XEXP (x4, 1);
                  x8 = XEXP (x5, 0);
                  if (rtx_equal_p (x8, operands[0]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[2])
                          && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_47 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x8, operands[2]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[0])
                          && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_59 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 8:
                  x5 = XEXP (x4, 1);
                  x8 = XEXP (x5, 0);
                  if (rtx_equal_p (x8, operands[0]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[2])
                          && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_48 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x8, operands[2]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[0])
                          && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_60 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 9:
                  x5 = XEXP (x4, 1);
                  x8 = XEXP (x5, 0);
                  if (rtx_equal_p (x8, operands[0]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[2])
                          && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_49 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x8, operands[2]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[0])
                          && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_61 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 10:
                  if (
#line 1895 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_71 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          if (!memory_operand (operands[1], E_HImode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern40 (x4, 
E_HImode) != 0
              || !
#line 1926 "../../gcc/config/rx/rx.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_77 (insn, operands);

        case E_QImode:
          if (rx_restricted_mem_operand (operands[1], E_QImode))
            {
              x4 = PATTERN (peep2_next_insn (1));
              switch (pattern39 (x4))
                {
                case 0:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_11 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_27 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 1:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_12 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_28 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 2:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_29 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 3:
                  x10 = XVECEXP (x4, 0, 0);
                  x11 = XEXP (x10, 1);
                  x12 = XEXP (x11, 0);
                  if (rtx_equal_p (x12, operands[0]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[2])
                          && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_14 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x12, operands[2]))
                    {
                      x13 = XEXP (x11, 1);
                      if (rtx_equal_p (x13, operands[0])
                          && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_30 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 4:
                  if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_41 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 5:
                  if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_42 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 6:
                  if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_43 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 7:
                  x5 = XEXP (x4, 1);
                  x8 = XEXP (x5, 0);
                  if (rtx_equal_p (x8, operands[0]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[2])
                          && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_53 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x8, operands[2]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[0])
                          && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_65 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 8:
                  x5 = XEXP (x4, 1);
                  x8 = XEXP (x5, 0);
                  if (rtx_equal_p (x8, operands[0]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[2])
                          && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_54 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x8, operands[2]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[0])
                          && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_66 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 9:
                  x5 = XEXP (x4, 1);
                  x8 = XEXP (x5, 0);
                  if (rtx_equal_p (x8, operands[0]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[2])
                          && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_55 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (rtx_equal_p (x8, operands[2]))
                    {
                      x6 = XEXP (x5, 1);
                      if (rtx_equal_p (x6, operands[0])
                          && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_67 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case 10:
                  if (
#line 1895 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_73 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          if (!memory_operand (operands[1], E_QImode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern40 (x4, 
E_QImode) != 0
              || !
#line 1926 "../../gcc/config/rx/rx.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_79 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      return peephole2_1 (x1, insn, pmatch_len_);

    default:
      return NULL;
    }
}
