/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      if (!rx_source_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      res = pattern2 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case SIGN_EXTEND:
      res = pattern2 (x3);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!rx_shift_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!rx_source_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern32 (x3); /* [-1, 1] */
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!rx_source_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 16)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x5;
          switch (GET_MODE (x2))
            {
            case E_CCmode:
              if (GET_MODE (x3) != E_CCmode
                  || !register_operand (operands[0], E_SImode)
                  || !rx_source_operand (operands[1], E_SImode)
                  || !
#line 194 "../../gcc/config/rx/rx.md"
(reload_completed))
                return -1;
              return 2; /* *cmpsi */

            case E_CC_Fmode:
              if (GET_MODE (x3) != E_CC_Fmode
                  || !register_operand (operands[0], E_SFmode)
                  || !rx_source_operand (operands[1], E_SFmode)
                  || !
#line 298 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS && reload_completed))
                return -1;
              return 7; /* *cmpsf */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern30 (x1))
            {
            case 0:
              if (!
#line 1934 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 129; /* comparesi3_zero_extendhi */

            case 1:
              if (!
#line 1934 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 131; /* comparesi3_zero_extendqi */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern30 (x1))
            {
            case 0:
              if (!
#line 1934 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 130; /* comparesi3_sign_extendhi */

            case 1:
              if (!
#line 1934 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 132; /* comparesi3_sign_extendqi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CC_ZSmode
          || GET_MODE (x3) != E_CC_ZSmode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!rx_source_operand (operands[1], E_SImode)
          || !
#line 258 "../../gcc/config/rx/rx.md"
(reload_completed))
        return -1;
      return 5; /* *tstsi */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_20 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_15 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 1);
              if (GET_CODE (x3) == MEM
                  && pattern23 (x1) == 0
                  && pattern50 (x1) == 0
                  && 
#line 2502 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
                return 155; /* rx_cpymem */
            }
          break;

        case 7:
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_18 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[1] = x1;
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_CODE (x3))
            {
            case PLUS:
              x5 = XEXP (x3, 0);
              if (!register_operand (x5, E_SImode))
                return -1;
              x6 = XEXP (x3, 1);
              if (!rx_source_operand (x6, E_SImode))
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x7))
                {
                case CLOBBER:
                  x8 = XEXP (x7, 0);
                  if (GET_CODE (x8) != REG
                      || REGNO (x8) != 16
                      || GET_MODE (x8) != E_CCmode)
                    return -1;
                  operands[1] = x5;
                  operands[2] = x6;
                  return 42; /* addsi3_internal */

                case SET:
                  if (pnum_clobbers == NULL)
                    return -1;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != PLUS
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != PLUS
                      || GET_MODE (x10) != E_SImode)
                    return -1;
                  x11 = XEXP (x10, 0);
                  if (GET_CODE (x11) != LTU
                      || GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 0);
                  if (GET_CODE (x12) != PLUS
                      || GET_MODE (x12) != E_SImode)
                    return -1;
                  operands[2] = x5;
                  operands[3] = x6;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x10, 1);
                  operands[4] = x13;
                  if (!register_operand (operands[4], E_SImode))
                    return -1;
                  x14 = XEXP (x9, 1);
                  operands[5] = x14;
                  if (!rx_source_operand (operands[5], E_SImode))
                    return -1;
                  x15 = XEXP (x12, 0);
                  if (!rtx_equal_p (x15, operands[2]))
                    return -1;
                  x16 = XEXP (x12, 1);
                  if (!rtx_equal_p (x16, operands[3]))
                    return -1;
                  x17 = XEXP (x11, 1);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  *pnum_clobbers = 2;
                  return 46; /* adddi3_internal */

                default:
                  return -1;
                }

            case MINUS:
              x7 = XVECEXP (x1, 0, 1);
              if (pattern9 (x7, 
16, 
CLOBBER, 
E_CCmode) != 0)
                return -1;
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x3, 1);
              operands[2] = x6;
              if (!rx_source_operand (operands[2], E_SImode))
                return -1;
              return 82; /* subsi3 */

            default:
              return -1;
            }

        case 4:
          if (pattern7 (x1) != 0)
            return -1;
          return 46; /* adddi3_internal */

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 12; /* simple_return */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != RETURN)
                return -1;
              return 15; /* fast_interrupt_return */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != RETURN)
                return -1;
              return 16; /* exception_return */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != RETURN)
                return -1;
              return 17; /* naked_return */

            case 41:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 164; /* mvtachi */

            case 42:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 165; /* mvtaclo */

            case 45:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              return 166; /* racw */

            case 31:
              if (pnum_clobbers == NULL
                  || GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 170; /* clrpsw */

            case 50:
              if (pnum_clobbers == NULL
                  || GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 171; /* setpsw */

            case 44:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              return 174; /* mvtipl */

            case 30:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 175; /* brk */

            case 32:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              return 176; /* int */

            case 51:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 177; /* wait */

            default:
              return -1;
            }

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x1, 1) != 43
              || GET_MODE (x1) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          operands[1] = x7;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 173; /* mvtc */

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x18 = XEXP (x1, 0);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != E_QImode)
        return -1;
      x19 = XEXP (x1, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x18, 0);
      operands[0] = x20;
      if (!rx_call_operand (operands[0], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 18; /* call_internal */

    case UNSPEC:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 33:
              return 158; /* machi */

            case 34:
              return 159; /* maclo */

            case 35:
              return 160; /* mulhi */

            case 36:
              return 161; /* mullo */

            default:
              return -1;
            }

        case 7:
          if (pnum_clobbers == NULL
              || XINT (x1, 1) != 47)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 1
              || GET_MODE (x7) != E_SImode)
            return -1;
          x21 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 2
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x22) != REG
              || REGNO (x22) != 3
              || GET_MODE (x22) != E_SImode)
            return -1;
          x23 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 4
              || GET_MODE (x23) != E_SImode)
            return -1;
          x24 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x24) != REG
              || REGNO (x24) != 5
              || GET_MODE (x24) != E_SImode)
            return -1;
          x25 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 6
              || GET_MODE (x25) != E_SImode
              || !
#line 2724 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
            return -1;
          *pnum_clobbers = 3;
          return 167; /* rmpa */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 179; /* nop */

    default:
      return -1;
    }
}
