/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, int *pnum_clobbers, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!rx_compare_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern10 (x1, 
E_SImode); /* [-1, 0] */

        case E_SFmode:
          if (pattern10 (x1, 
E_SFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern11 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case SIGN_EXTEND:
      res = pattern11 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 3
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 2);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 16
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case PLUS:
          return 0;

        case AND:
          return 1;

        case IOR:
          return 2;

        case XOR:
          return 3;

        case DIV:
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          x8 = XEXP (x6, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          return 4;

        case UDIV:
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          x8 = XEXP (x6, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          return 5;

        case MINUS:
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          x8 = XEXP (x6, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          return 6;

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x1, 1);
      switch (GET_CODE (x9))
        {
        case SMAX:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x1, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 7;

        case SMIN:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x1, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case MULT:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x1, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case COMPARE:
          if (GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XEXP (x1, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 16
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x9, 1);
          if (!rtx_equal_p (x12, operands[0]))
            return -1;
          return 10;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (pattern22 (x1) != 0)
        return -1;
      return 86; /* subdi3_internal */

    case MEM:
      if (pnum_clobbers == NULL
          || pattern23 (x1) != 0
          || !
#line 2502 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
        return -1;
      *pnum_clobbers = 3;
      return 155; /* rx_cpymem */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 3
          || pattern25 (x3) != 0)
        return -1;
      switch (XINT (x3, 1))
        {
        case 22:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 1
              || GET_MODE (x5) != E_SImode
              || pattern51 (x1, 
3) != 0
              || !
#line 2533 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
            return -1;
          return 156; /* rx_setmem */

        case 24:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != USE)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!memory_operand (operands[1], E_BLKmode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!memory_operand (operands[2], E_BLKmode)
              || !
#line 2606 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
            return -1;
          *pnum_clobbers = 4;
          return 157; /* rx_cmpstrn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
